#include "afw.h"
#include <signal.h>
/** \file afw.cpp
 *  \brief I[fBIEt[[NEt@C
 *  \author AiOEfoCZY
 *  \version 1.0
 *  \date    2006.Sep.8
 *
 * ̃t@CVisualDSP++ 4.5̃TvEAvP[VATalkTrhough
 * ĕύX̂łBEZ-KIT BF533̃I[fBIER[fBbN𗘗p
 * ߂̊֐QȂBB
 */
namespace afw{
    /** AD1836Ȁ
    *
    * R[fbN邽߂ɁAZbgpX^ASPIoRŏXgO𑗂B
    * 
    */
    void Init1836(void)
    {
    	int i;
    	int j;
    	static unsigned char ucActive_LED = 0x01;

    	// write to Port A to reset AD1836
    	*pFlashA_PortA_Data &= ~ucActive_LED;
    	ssync();
	
    	// keep reset low
    	for (i=0; i<1000000; i++) 
    		asm volatile("nop;");
		
    	// write to Port A to enable AD1836
    	*pFlashA_PortA_Data |= ucActive_LED;
    	ssync();
	
    	// wait to recover from reset
    	for (i=0; i<1000000; i++) 
    		asm volatile("nop;");

    	// Enable PF4
    	*pSPI_FLG = FLS4;
    	// Set baud rate SCK = HCLK/(2*SPIBAUD) SCK = 2MHz	
    	*pSPI_BAUD = 16;
    	// configure spi port
    	// SPI DMA write, 16-bit data, MSB first, SPI Master
    	*pSPI_CTL = TIMOD_DMA_TX | SIZE | MSTR;
	
    	// Set up DMA5 to transmit
    	// Map DMA5 to SPI
    	*pDMA5_PERIPHERAL_MAP	= 0x5000;
	
    	// Configure DMA5
    	// 16-bit transfers
    	*pDMA5_CONFIG = WDSIZE_16;
    	// Start address of data buffer
    	*pDMA5_START_ADDR = (void *)sCodec1836TxRegs;
    	// DMA inner loop count
    	*pDMA5_X_COUNT = CODEC_1836_REGS_LENGTH;
    	// Inner loop address increment
    	*pDMA5_X_MODIFY = 2;
	
    	// enable DMAs
    	*pDMA5_CONFIG |= DMAEN;
    	// enable spi
    	*pSPI_CTL |= SPE;
	
    	// SPI DMȀI҂B̃^C~OɂĂ͉oȂƂB
    	for (j=0; j<1000000; j++) 
    		asm volatile ("nop;");
	
    	// disable spi
    	*pSPI_CTL = 0x0000;
    }


    /** SPORT0̏
       * 
       * I[fBIR[fbNɐڑĂSPORT0BVA
       * tH[}bg̓}``lŁANbNуt[M͊OB̊֐ǂ񂾒iK
       * ł́A|[g̓fBZ[û܂܂ɂĂB
       *
       * 
       * ڍׂADSP-BF533 Hardware Reference "Stereo Serial Operation" QƂ̂ƁB
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       *
       * ӁFEZ-KIT Lite BF537 Rev 1.0̃[U[SPORT̃NbNуt[
       * MŐݒɕύXȂ΂ȂȂB
       */
    void Init_Sport0(void)
    {
    	// Sport0 receive configuration
    	// External CLK, External Frame sync, MSB first
    	// 32-bit data
    	*pSPORT0_RCR1 = RFSR;
    	*pSPORT0_RCR2 = SLEN_32;
	
    	// Sport0 transmit configuration
    	// External CLK, External Frame sync, MSB first
    	// 24-bit data
    	*pSPORT0_TCR1 = TFSR;
    	*pSPORT0_TCR2 = SLEN_32;
	
    	// Enable MCM 8 transmit & receive channels
    	*pSPORT0_MTCS0 = 0x000000FF;
    	*pSPORT0_MRCS0 = 0x000000FF;
	
    	// Set MCM configuration register and enable MCM mode
    	*pSPORT0_MCMC1 = 0x0000;
    	*pSPORT0_MCMC2 = 0x101c;
    }


    /** SPORT DMȀ
       * 
       * SPORT0ɐڑĂDMAݒ肷BDMA1MADMA2MłB
       * I[fBIM16rbgȏ̒̂Ń[hTCY32bit, 
       * AM̂߂ɃI[gobt@A[hgB܂AgvEobt@
       * 邽߂ɁADMA]2ōsA3C̃obt@mۂĊeC
       * ]I邽тɊ荞݂𔭐B
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void Init_DMA(void)
    {
    	int i, field;
	
    	// Set up DMA1 to receive
    	// Map DMA1 to Sport0 RX
    	*pDMA1_PERIPHERAL_MAP = 0x1000;
	
    	// Configure DMA1
    	// 32-bit transfers, Interrupt on completion, Autobuffer mode
    	*pDMA1_CONFIG = WNR | WDSIZE_32 | DI_EN | DI_SEL | FLOW_Autobuffer | DMA2D ;
    	// Start address of data buffer
    	*pDMA1_START_ADDR = (void *)iRxBuffer1;
    	// DMA inner loop count
    	*pDMA1_X_COUNT = SLOT_PER_SAMPLE * SAMPLES_PER_INTR;
    	// Inner loop address increment
    	*pDMA1_X_MODIFY	= sizeof(int);
    	// DMA outer loop count, triple buffer
    	*pDMA1_Y_COUNT = INTR_PER_BUFFER;
    	// Outer loop address increment
    	*pDMA1_Y_MODIFY	= sizeof(int);	
	
    	// Set up DMA2 to transmit
    	// Map DMA2 to Sport0 TX
    	*pDMA2_PERIPHERAL_MAP = 0x2000;
	
    	// Configure DMA2
    	// 32-bit transfers, Autobuffer mode
    	*pDMA2_CONFIG = WDSIZE_32 | FLOW_Autobuffer | DMA2D;
    	// Start address of data buffer
    	*pDMA2_START_ADDR = (void *)iTxBuffer1;
    	// DMA inner loop count
    	*pDMA2_X_COUNT = SLOT_PER_SAMPLE * SAMPLES_PER_INTR;
    	// Inner loop address increment
    	*pDMA2_X_MODIFY	= sizeof(int);
    	// DMA outer loop count, triple buffere
    	*pDMA2_Y_COUNT = INTR_PER_BUFFER;
    	// Outer loop address increment
    	*pDMA2_Y_MODIFY	= sizeof(int);	
	
    	for ( i=0; i<SAMPLES_PER_INTR; i++ ){
    		for ( field=0; field<INTR_PER_BUFFER; field ++ ){
    			// Clean up buffer for transfer
    			iRxBuffer1[field][i][INTERNAL_ADC_L0] = 0;
    			iRxBuffer1[field][i][INTERNAL_ADC_R0] = 0;
    			iRxBuffer1[field][i][INTERNAL_ADC_L1] = 0;
    			iRxBuffer1[field][i][INTERNAL_ADC_R1] = 0;
    			iTxBuffer1[field][i][INTERNAL_DAC_L0] = 0;
    			iTxBuffer1[field][i][INTERNAL_DAC_R0] = 0;
    			iTxBuffer1[field][i][INTERNAL_DAC_L1] = 0;
    			iTxBuffer1[field][i][INTERNAL_DAC_R1] = 0;
    			iTxBuffer1[field][i][INTERNAL_DAC_L2] = 0;
    			iTxBuffer1[field][i][INTERNAL_DAC_R2] = 0;
    		}
    	}
    }

    /** 荞݂̃Cl[u
       * 
       * SPORT0 M݂LBSPORT0 M荞݂IVG9ŏ̂ŁÅ蓖Ăݒ肷B
       * afw::init()IɌĂяôŁAvO}̊֐𖾎IɌĂԕKv͂ȂB
       */
    void Init_Sport_Interrupts(void)
    {
    	// enable Sport0 RX interrupt
    	*pSIC_IMASK = 0x00000200;
    	ssync();
    }


    void start(void)
    {
    	// enable DMAs
    	*pDMA2_CONFIG |= DMAEN;
    	*pDMA1_CONFIG |= DMAEN;
	
    	// enable Sport0 TX and RX
    	*pSPORT0_TCR1 |= TSPEN;
    	*pSPORT0_RCR1 |= RSPEN;
    }

    void init(void)
    {
    	Init1836();
    	Init_Sport0();
    	Init_DMA();
    	Init_Sport_Interrupts();
    	
    	initProcessData( SAMPLES_PER_INTR );
    }
    
    /** SPORT0MDMA荞݃nh
     *
     * ISRSPORT0̎MDMA犄荞݂邽тɁA \ref cec̊荞݃nhĂяoA荞݂̃NA
     * gvEobt@̊ǗsBgvobt@̊Ǘ́ADMA1_CURR_Y_COUNT̒l
     * ƂɍsB
     *
     * DMA1_CURR_Y_COUNT́A]̍ŏɓDMA1_Y_COUNT̒lɐݒ肳A
     * C̓]I邲ƂɃfNgBAŌ̃C
     * ]́AfNgꂸ1̂܂܂ɗ܂B̌ʁAeC̓]I
     * ł́AݔƂɈȉ̂悤DMA1_CURR_Y_COUNT̒lω
     * - ŏ̃C̓]IBDMA1_CURR_Y_COUNT == 2BvZbTĂ悢obt@̓Y 0
     * - 2Ԗڂ̃C̓]IBDMA1_CURR_Y_COUNT == 1BvZbTĂ悢obt@̓Y 1
     * - 3Ԗڂ̃C̓]IBDMA1_CURR_Y_COUNT == 1BvZbTĂ悢obt@̓Y 2
     *
     * ̂ƂA\tgEFAƂ̓ɎgĂ悢̂DMAx_CURR_Y_COUNT2̏ꍇ
     * ݂̂łAƂ͌߂Ńobt@̓YCNgȂ΂ȂȂ킩B
     * vOł́A̓YƂbufferIdxĂĂB
     * 
     * gvobt@̊ǗIAMDMAobt@f[^oA
     * ȂĂ afw::processData ĂԁB
     * 
     * ȂASPORT0 RX荞݂̏sꍇɂ true AsȂƂɂ falseԂ
     */
  		

    bool ISR( void )
    {
    	static int field = 2;
    	short leftIn[SAMPLES_PER_INTR], rightIn[SAMPLES_PER_INTR];
    	short leftOut[SAMPLES_PER_INTR], rightOut[SAMPLES_PER_INTR];
		
    	if ( *pSIC_ISR & DMA1_IRQ ){			// SPORT0 RX (DMA1) ̊荞݂	
	    	// 荞݂̃NA
	    	*pDMA1_IRQ_STATUS = 0x0001;
	
		
	    	if (  2 == *pDMA2_CURR_Y_COUNT )
	    		field = 0;  // gvobt@̍ŏfieldϐ𓯊
	    	else
	    	    field ++;   // ȊOł͌߂ōXV
	
	    	for ( int i=0; i<SAMPLES_PER_INTR; i++ ){	// ׂẴTvɂ
	    		// DMAobt@̃f[^ׂȂ
	    		leftIn[i] = iRxBuffer1[field][i][INTERNAL_ADC_L0] >> 16;
	    		rightIn[i] = iRxBuffer1[field][i][INTERNAL_ADC_R0] >> 16;
	    	}
	    		// [U[M[`̌Ăяo
	    	processData( leftIn, rightIn, leftOut, rightOut, SAMPLES_PER_INTR );				
	
	    	for ( int i=0; i<SAMPLES_PER_INTR; i++ ){	// ׂẴTvɂ
	    		// DMAobt@Ƀf[^ׂȂ
	    		iTxBuffer1[field][i][INTERNAL_DAC_L0] = leftOut[i] << 16;
	    		iTxBuffer1[field][i][INTERNAL_DAC_R0] = rightOut[i] << 16;
	    	}
	    	return true;
    	}
    	else
    		return false;
    }


    /** R[fbNXgO
    *
    * SPIoRAD1836Aɑ鏉f[^Q
    * 
    */

    volatile short sCodec1836TxRegs[CODEC_1836_REGS_LENGTH] =
    {									
    					DAC_CONTROL_1	| 0x000,
    					DAC_CONTROL_2	| 0x000,
    					DAC_VOLUME_0	| 0x3ff,
    					DAC_VOLUME_1	| 0x3ff,
    					DAC_VOLUME_2	| 0x3ff,
    					DAC_VOLUME_3	| 0x3ff,
    					DAC_VOLUME_4	| 0x3ff,
    					DAC_VOLUME_5	| 0x3ff,
    					ADC_CONTROL_1	| 0x000,
    					ADC_CONTROL_2	| 0x180,
    					ADC_CONTROL_3	| 0x000
					
    };
/** I[fBIMpobt@
   * 
   * MDMAANZXASPORT TX`lɃf[^𑗂荞ނ߂̃obt@
   *
   * ŉʂ̎AD1836A8`lp8̗vfi[B2Ԗڂ̎́A
   * 1񂲂ƂɑMTvw肷B1̊荞݂̊ԂDMA]
   * f[^̗ʂ́A afw::SAMPLES_PER_INTR * 8 Ō܂B
   *
   * ŏʂ̎́A̔z񂪃gvobt@pł邱ƂB
   */
    volatile int iTxBuffer1[INTR_PER_BUFFER][SAMPLES_PER_INTR][SLOT_PER_SAMPLE];	// Need place for each sample
    
/** I[fBIMpobt@
   * 
   * MDMAANZXASPORT RX`l̃f[^ނ߂̃obt@
   *
   * ŉʂ̎AD1836A8`lp8̗vfi[B2Ԗڂ̎́A
   * 1񂲂ƂɎMTvw肷B1̊荞݂̊ԂDMA]
   * f[^̗ʂ́A afw::SAMPLES_PER_INTR * 8 Ō܂B
   *
   * ŏʂ̎́A̔z񂪃gvobt@pł邱ƂB
   */
    volatile int iRxBuffer1[INTR_PER_BUFFER][SAMPLES_PER_INTR][SLOT_PER_SAMPLE];	// 



}   // namespace afw
