/** \file ad7998.cpp
 *  \brief AD7998, AD7997vO
 *
 * ad7998::initAndStartŕϊJnAȌϊ𑱂B
 * ϊl ad7998::getValueŎ擾łB
 */
 
#include "ad7998.h"
#include "twi.h"
#include <ccblkfn.h>

namespace ad7998{
	
    const unsigned int CRR = 0;	    ///<	Conversion Result Register (Read)
    const unsigned int ASR = 1;	    ///<	Alert Status Register (Read/Write)
    const unsigned int CR = 2;	    ///<	Configuration Register (Read/Write)
    const unsigned int CTR = 3;	    ///<	Cycle Timer Register (Read/Write)
    const unsigned int DLR1 =4;	    ///<	DATALOW Reg CH1 (Read/Write)
    const unsigned int DHR1 =5;	    ///<	DATAHIGH Reg CH1 (Read/Write)
    const unsigned int HR1 = 6;	    ///<	Hysteresis Reg CH1 (Read/Write)
    const unsigned int DLR2 =7;	    ///<	DATALOW Reg CH2 (Read/Write)
    const unsigned int DHR2 =8;	    ///<	DATAHIGH Reg CH2 (Read/Write)
    const unsigned int HR2 = 9;	    ///<	Hysteresis Reg CH2 (Read/Write)
    const unsigned int DLR3 =10;	///<	DATALOW Reg CH3 (Read/Write)
    const unsigned int DHR3 =11;	///<	DATAHIGH Reg CH3 (Read/Write)
    const unsigned int HR3 = 12;	///<	Hysteresis Reg CH3 (Read/Write)
    const unsigned int DLR4 =13;	///<	DATALOW Reg CH4 (Read/Write)
    const unsigned int DHR4 =14;	///<	DATAHIGH Reg CH4 (Read/Write)
    const unsigned int HR4 = 15;	///<	Hysteresis Reg CH4 (Read/Write)

    const unsigned int ch1 = 0x0010;    ///< ad7998::CR̃`lwpBVin1
    const unsigned int ch2 = 0x0020;    ///< ad7998::CR̃`lwpBVin2
    const unsigned int ch3 = 0x0040;    ///< ad7998::CR̃`lwpBVin3
    const unsigned int ch4 = 0x0080;    ///< ad7998::CR̃`lwpBVin4
    const unsigned int ch5 = 0x0100;    ///< ad7998::CR̃`lwpBVin5
    const unsigned int ch6 = 0x0200;    ///< ad7998::CR̃`lwpBVin6
    const unsigned int ch7 = 0x0400;    ///< ad7998::CR̃`lwpBVin7
    const unsigned int ch8 = 0x0800;    ///< ad7998::CR̃`lwpBVin8
    const unsigned int fltr= 0x0008;    ///< ad7998::CR̐ݒpBtB^g
    
    const unsigned int VinSeq = 0x70;   ///< Mode2R}hB ad7998::CRŎw肵͂f[^A擾

/** AD7997foCXAhX
 * 
 * AD7998I2CAhXB
 */
const int AD7998 = 0x20;

/** ̒
 * 
 * AD7998ɑ鏉̒B
 */
const int initLen = 3;

/** R}h̒
 * 
 * AD7998ɑR}h̒B
 */
const int cmdLen = 1;

/** AD7998
 * 
 * Rg[EWX^̃AhX1oCgƁA̓e2oCgȂB
 */
const unsigned char initAD7998Str[initLen] = { ad7998::CR , 0x0F, 0xF0 | ad7998::fltr };
/** AD7998R}h
 * 
 * AD7998̃[h2]ŗpR}hB
 */
const unsigned char cmdAD7998Read[cmdLen] = { ad7998::VinSeq };

/** ADC`l
 * 
 * AD7998̃`lB
 */
const int chNum = 8;

/** f[^Mobt@
 * 
 * TWIp̎Mobt@BAD7998̕ϊʂ󂯎B
 */

	unsigned char rxBuffer[chNum*2] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	
/** f[^Mobt@
 * 
 * ad7998::rxBuffer̒lڂĂB
 */

	unsigned char rxValue[chNum*2];
	
	
	void callBack( bool rcv );
	
    void init(void)
    {
    }
    
    void start(void)
    {
    	twi::writeAsync(    // Rg[WX^̐ݒ   
    	            AD7998,             // foCXAhX
    	            initAD7998Str,      // AD7998XgO
    	            initLen,            // XgO
    	            ad7998::callBack    // IcallBack֐Ă
    	          );
    }
    
    shortfract getValue( adcChannel vin )
    {
    	unsigned int imask;
    	shortfract val;
    	short temp;
    	int index;
    	
    	imask = cli();                              // ݋֎~
    	
    	index = (int)vin*2;                         // `lԍoCgECfbNXɕϊ
    	temp = ( rxValue[index]<<8 ) + rxValue[index+1];     // rbOEGfBA̒lo
    	temp &= 0x0FFF;                             // `lԍ}NXEIt
    	val.v = temp << 3;                          // 12bitl15bitl(t16bit̐̕)ɕϊ
    	
    	sti(imask);                                 // ݋֎~

      	return val;
    }
    
    /** R[obN֐
     * \param rcv MR[obNȂ1
     *
     * twi::writeReadAsync() ֐ɓnR[obNBAD7998̕ϊf[^ǂݍ݊
     * gKɂāAMf[^̎擾sB
    */
   	void callBack( bool rcv )
	{
    	unsigned int imask;
    	
    	imask = cli();  // ݋֎~
    	
        for ( int i= 0; i<chNum*2; i++ )
            rxValue[i] = rxBuffer[i];          // Mf[^Rs[ĂB
            
    	sti(imask);     // ݋֎~

    	twi::writeReadAsync( 
                AD7998,             // I2CfoCXEAhXiMj
                cmdAD7998Read,      // Mode2]w肷R}h
                cmdLen,             // R}h
                AD7998,             // I2CfoCXEAhXiMj
                rxBuffer,           // f[^Mobt@
                chNum*2,            // f[^MoCg
                ad7998::callBack    // R[obN֐
            );     // Mode2ǂݏoݒ

	}

};



