#include <cdefBF53x.h>
#include <ccblkfn.h>
#include "twi.h"

/** \file twi.cpp
 *  \brief TWIhCot@C
 *
 * ̃t@CADSP-BF537TWIphCõhCot@CłB
 * 
 * : Analog Devices IncуAiOEfoCZYЂ́A
 * ̃vO̗pɂĐ邢ȂɂӔC𕉂
 * ȂB
 */
 
namespace twi{

/** f[^]obt@EAhX
 * 
 * ɑMf[^̃AhXA邢͎Mf[^i[obt@̃AhXB
 */
    unsigned char * dataPtr;

/** Repeated StartɎgobt@EAhX
 * 
 * ݂̓]̏IRepeated Startsꍇ́A̓]sobt@
 * AhX̕ϐɊi[B
 */
    unsigned char * nextPtr;
    
/** Repeated Start̃foCXEAhX
 * 
 * ݂̓]̏IRepeated Startsꍇ́A̓]sTWIfoCX
 * AhX̕ϐɊi[BRepeated Startsۂ̔fɂĝ
 * Repeated StartgȂꍇ͕K0ɃZbgB
 */
    unsigned char nextAddress = 0;
    
/** ]ς݃oCg
 * 
 * is̑MA邢͎Mf[^𐔂B
 */
    unsigned int transferedCount;
    
/** ]oCg
 * 
 * is̑MA邢͎Mɂ鑍]oCgB
 */
    unsigned int countToBeTransfer;
    
/** Repeated Start̓]oCg
 * 
 * ݂̓]̏IRepeated Startsꍇ́A
 * ̓]ł̑MA邢͎Mɂ鑍]oCgB
 */
    unsigned int nextTransfer;

/** MtO
 * 
 * ݂̓]MȂΐ^AMȂ΋U
 */
    bool rcv; 

/** R[obN֐
 * 
 * ݂̓]MȂΐ^AMȂ΋U
 */
    void ( * userCallBack )(bool);

    void init( unsigned int sclkMHz )
    {
        *pTWI_CONTROL = TWI_ENA | (sclkMHz / 10);     // TWINbN10MHzɐݒ
        *pTWI_CLKDIV = CLKHI(50) | CLKLOW(50);        // Hihg/LowԂ250NbNɐݒB悻20kHzNbN
        *pTWI_FIFO_CTL = XMTFLUSH | RCVFLUSH;         // FIFOtbV
                // : 8bitf[^]̏ꍇAFIFO̐ݒ͕KXMTINTLEN=1, RCVINTLEN=0
                // 邱ƁB̏ꍇAMFIFOȂ犄荞݁AMFIFO
                // ȂȂ犄荞݂B̐ݒł͑MFIFÕA_[]T
                // 邪Arepeated start̏(Ō̑M荞݂DCNT=0̂ƂMDIR])
                // 𖞂߂ɂ͎dȂBA_[]T͌ƂĂ1byteM
                // ԕ̗]T͂B400kbpŝƂA20uSłB
        *pTWI_FIFO_CTL = XMTINTLEN;                   // M:1oCgłf[^Ί荞݁BM:obt@Ȃ犄荞
        *pTWI_SLAVE_CTL = 0;                          // X[u@\fBZ[u
        *pSIC_IMASK |= IRQ_TWI;
    }
    
    void start( void )
    {
    }
       
    bool ISR( void )
    {
        unsigned int istat;
        
        if ( *pSIC_ISR & IRQ_TWI ){                         // TWI荞݂
            istat = *pTWI_INT_STAT;                         // ݏ󋵂̎擾
            if ( istat & XMTSERV ) {                        // M荞݂
                if ( countToBeTransfer == transferedCount ){// SM
                    *pTWI_INT_MASK &= ~XMTSERV;             // M荞݋֎~
                    if ( nextAddress )                      // repeated Startg
                       *pTWI_MASTER_CTL |= MDIR;            // ]M
                }
                else {                                      // ܂MIĂȂ
                    *pTWI_XMT_DATA8 = *(dataPtr++);         // 1oCg]
                    transferedCount ++;                     // ]oCgXV
                }
                *pTWI_INT_STAT = XMTSERV;                   // M荞݃NA
            }
            else if ( istat & RCVSERV ) {                   // M荞݂
                *(dataPtr++) = *pTWI_RCV_DATA8;             // 1oCg]
                *pTWI_INT_STAT = RCVSERV;                   // M荞݃NA
                transferedCount ++;                         // ]oCgXV
            }
            else if ( istat & MCOMP ){                      // f[^]
                *pTWI_INT_STAT = MCOMP;                     // ݃NA
                *pTWI_INT_MASK &= ~(RCVSERV|XMTSERV|MCOMP); // 荞݂֎~ɂ
                if ( rcv ){                                 // M
                    if ( *pTWI_FIFO_STAT & RCVSTAT ) {      // FIFOɃf[^cĂ邩
                        *(dataPtr++) = *pTWI_RCV_DATA8;     // Ō̎MoCg擾
                        transferedCount ++;                 // ]oCgXV
                    }
                    if ( userCallBack )                     // MR[obN͕Kv
                        userCallBack(true);                 // R[obNĂяo
                }
                else{                                       // MI
                	if ( nextAddress )                      // repoeated StartgĂ邩
                	    readAsync( nextAddress, nextPtr, nextTransfer, userCallBack );
                    else if ( userCallBack )                // MR[obN͕Kv
                        userCallBack(false);                // R[obNĂяo
                }
            }
            ssync();
            return true;                                    // ݏsƂm点
        }                                                   // TWI荞ݏI
        else
            return false;                                   // ݏsȂ
    }
    
    void readAsync( 
                unsigned char address,      // ʐMI2CAhX
                unsigned char data[],       // Mobt@EAhX
                unsigned int count,         // Mf[^
                void ( * callback )( bool ) // MĂяoR[obN
                )
    {
        rcv = true;                         // M
        nextAddress = 0;                    // Repeated StartgȂB
        countToBeTransfer = count;          // Mf[^
        dataPtr = (unsigned char *)data;    // obt@E|C^Zbg
        userCallBack = callback;            // R[obN֐Zbg
        *pTWI_INT_MASK = 0;                 // 荞݂ꎞ֎~
        *pTWI_MASTER_ADDR = address;        // 7bit AhXݒ
        transferedCount = 0;                // Mς݃f[^
        *pTWI_MASTER_CTL = MEN | MDIR | DCNT & ( count << 6 ); // }X^[[hAMAAhXݒ
        *pTWI_INT_MASK = RCVSERV | MCOMP;   // ݃}XNݒ
    } 
    
/** writeAsync̉֐
 * @param address ݂sfoCX7bit TWIAhXB
 * @param data ރf[^̔z
 * @param count ݃f[^BPʂ̓oCgB
 * @param callback M荞ݎɌĂяoR[obN֐BNULLw肷ƉĂяoȂB
 *
 * I2CM̏́B twi::writeAsync twi::writeReadAsynćA
 * repeated StartɊւݒsAc̏̊֐
 * ۓB
 *
 * writeAsync֐́AI2CfoCXAhXݒAŏ1oCg
 * FIFOɏł瑗MCl[uɂB
 */
        // M֐̉B
    void writeAsyncSub( 
                unsigned char address,      // ʐMI2CAhX
                const unsigned char data[], // Mobt@EAhX
                unsigned int count,         // MoCg
                void ( * callback )( bool ) // MĂяoR[obN
                )
    {
        rcv = false;                        // M
        countToBeTransfer = count;          // Mf[^
        dataPtr = (unsigned char *)data;    // obt@E|C^Zbg
        userCallBack = callback;            // R[obN֐Zbg
        *pTWI_INT_MASK = 0;                 // 荞݂ꎞ֎~
        *pTWI_MASTER_ADDR = address;        // 7bit AhXݒ
        *pTWI_XMT_DATA8 = *(dataPtr++);     // ŏ1oCg]
        transferedCount = 1;                // Mς݃f[^
  
        *pTWI_MASTER_CTL |= MEN | DCNT & ( count << 6 ); // }X^[[hAMAAhXݒ
        *pTWI_INT_MASK = XMTSERV | MCOMP;   // ݃}XNݒ
    }
                
        // M֐BREPEATED STARTsȂݒőMs
    void writeAsync( 
                unsigned char address,      // ʐMI2CAhX
                const unsigned char data[], // Mobt@EAhX
                unsigned int count,         // MoCg
                void ( * callback )( bool ) // MĂяoR[obN
                )
    {
        nextAddress = 0;                    // Repeated StartgȂB
        *pTWI_MASTER_CTL = 0;               // Repeated StartgȂ
                                            // 又
        writeAsyncSub( address, data, count, callback );
    }
    
    void writeReadAsync( 
                unsigned char wAddress,      // ʐMI2CAhX(M)
                const unsigned char wData[], // Mobt@EAhX
                unsigned int wCount,         // MoCg
                unsigned char rAddress,      // ʐMI2CAhX(M)
                const unsigned char rData[], // Mobt@EAhX
                unsigned int rCount,         // MoCg
                void ( * callback )( bool )  // MĂяoR[obN
                )
    {
        nextTransfer = rCount;              // Repeated Start̎Mf[^
        nextPtr = (unsigned char *)rData;   // Repeated Start̎Mobt@
        nextAddress = rAddress;             // Repeated Start̎MfoCXAhX
        *pTWI_MASTER_CTL = RSTART;          // Repeated Startg
                                            // 又
        writeAsyncSub( wAddress, wData, wCount, callback );
    }

};


